// Translateable text for clickable handle of show / hide section
var expandtext = 'Show this section';
var expandtitle = 'Click here to show the hidden section';
var collapsetext = 'Hide this section';
var collapsetitle = 'Click here to hide this section';

// Clickable handle to toggle expand / collapse section
var expandrow = '<div class="handlerow"></div>';
var expandhandle = '<a class="expandhandle" href="" title="Click here to expand the hidden section">Show this section</a>';
var sectiontitle = '';
var buttons = '<input class="expandAllBtn" type="button" value="Expand All"/> <input class="collapseAllBtn" type="button" value="Collapse All"/>';
var icons = '<div style="float: right"><label class="expandAllDiv" style="cursor: pointer;"><img src="icon_expand_all.gif" alt"Expand all fields"/><span>Expand All</span></label> <label class="collapseAllDiv" style="cursor: pointer;"><img src="icon_collapse_all.gif" alt"Collapse all fields"/><span>Collapse All</span></label></div><div style="height: 22px"></div>'

$(document).ready(function(){

	// with the new code the writer should be sure not to have tables without that structure if the body has class collapse
	// if the body doesn't have class collapse it will be ignored
	$("body.collapse").find("table").each(function () {
		// selects the parent div
		// table -> .tableholder -> collapsable
		divCollapsible = $(this).parent().parent();
		
		// check for nested tables, if the handlerow is created already
		if (divCollapsible.children(".handlerow").length > 0) return true;
		
		if (divCollapsible.find(".title")) {
			sectiontitle = ': ' + divCollapsible.find(".title").text();
			// alert('Section title ='+sectiontitle);
		};

		$thishandle = $(expandhandle).append(sectiontitle);
		$thisrow = $(expandrow).append($thishandle);
		
		// Add clickable handle as first child element in the collapsable div
		divCollapsible.prepend($thisrow);
		//	Hide all but first child element, which is the handle to remain visible
		divCollapsible.children().slice(1).hide();
		// Make KC adjust content area for change of content height
		if (typeof kc === "object" && typeof kc.resize === "function") kc.resize();
	});
	
	// puts the buttons after the latestprod; next so they are not in the shadow of latestprod
	// if ($("body").hasClass("collapse")) $(".runningheader").append(buttons);
	if ($("body").hasClass("collapse") || $("div.collapse")) $(".runningheader").append(icons);
	
	// old code for expandable sections, requires every section to have class="collapse ..."
	$( "div.collapse" ).each(function( i ) {
		// If section has a title, append as last child element of the expandhandle
		if ($(this).find(".title")) {
			sectiontitle = ': ' + $(this).find(".title").text();
			// alert('Section title ='+sectiontitle);
		};

		$thishandle = $(expandhandle).append(sectiontitle);
		$thisrow = $(expandrow).append($thishandle);
		
		// Add clickable handle as first child element in the collapsable div
		$(this).prepend($thisrow);
		//	Hide all but first child element, which is the handle to remain visible
		$(this).children().slice(1).hide();
		// Make KC adjust content area for change of content height
		if (typeof kc === "object" && typeof kc.resize === "function") kc.resize();
	});
	
	$( ".handlerow" ).click(function() {

		var $expandhandle = $(this).children().slice(0,1);

		if ($(this).hasClass("hide")) {
			hideElem($(this));
		}else {
			showElem($(this));
		}
		return false;
	});
	
	function hideElem(elem) {
		var $expandhandle = elem.children().slice(0,1);
		
		// If section has a title, append as last child element of the expandhandle
		nextel = elem.next();
		if ($(nextel).hasClass('sectiontitle')) {
			sectiontitle = ': ' + $(nextel).text();
			$expandhandle.text(expandtext + sectiontitle);
		}else {
			$expandhandle.text(expandtext);
		};

		$expandhandle.attr('title',expandtitle);
		//	Hide all but first child element, which is the handle to remain visible
		elem.siblings().hide();
		elem.removeClass("hide");
		// Make KC adjust content area for change of content height
		if (typeof kc === "object" && typeof kc.resize === "function") kc.resize();
	}
	
	function showElem(elem){
		var $expandhandle = elem.children().slice(0,1);
	
		// alert('Div is not hidden '+$(this).attr('class')); 
		$expandhandle.text(collapsetext);
		$expandhandle.attr('title',collapsetitle);
		elem.siblings().show();
		elem.addClass("hide");
		// Make KC adjust content area for change of content height
		if (typeof kc === "object" && typeof kc.resize === "function") kc.resize();
	}
	
	$(  ".expandAllDiv" ).click(function() {
		expandAll();
	});
	
	$(  ".collapseAllDiv" ).click(function() {
		// collapses all shown topics when a button is pressed
		$("body div.handlerow").each(function() {
			if ($(this).hasClass("hide")) {
				hideElem($(this));
			}
		});
	});
	
	function expandAll(){
		// expands all hidden topics when a button is pressed
		$("body div.handlerow").each(function() {
			// weird error if if the class is not hidden
			if (!$(this).hasClass("hide")) {
				showElem($(this));
			}
		});
	}
	
	$(window).bind('keydown', function(event) {
		// check if CTRL + F is pressed
		// if required for other CTRL + key combinations they can be added in the switch event 
		// event.metaKey for mac support
		if (event.ctrlKey || event.metaKey) {
			switch (String.fromCharCode(event.which).toLowerCase()) {
			case 'f':
				expandAll();
				break;
			}
			// add more CTRL + BTN here if needed
		}
	});
});